#include <stdio.h>
#include <fcntl.h>
#include <stddef.h>
#include <unistd.h>

#define RANDOM_BUFFER_SIZE 16384

static size_t index = RANDOM_BUFFER_SIZE;
static size_t value_buff[RANDOM_BUFFER_SIZE];
static int random_fd = -1;

void
random_init(void)
{
	random_fd = open("/dev/urandom", O_RDONLY);

	if (random_fd < 0)
		printf("[random:error] Failed to open /dev/urandom\n");
}

size_t
randint(size_t max)
{
	if (index >= RANDOM_BUFFER_SIZE) {
		read(random_fd, value_buff, 8 * RANDOM_BUFFER_SIZE);

		index = 0;
	}

	size_t rv = value_buff[index] % max;
	index++;

	return rv;
}
